#ifndef _SC_META_IMG_H_
#define _SC_META_IMG_H_

// C++  0  NULL ̍邽߂̃NX`
#include <my_null.h>

//! 萔`
/*!
 *	̖OԂ́AscMetaImg NXň萔`B
 *
 */
namespace ns_scMetaImg
{
	enum
	{
		//! Red Channel = 0
		RED		= 0,
		//! Green Channel = 1
		GREEN	= 1,
		//! Blue Channel = 2
		BLUE	= 2,
	};
}

//! pbg߂̍\
/*!
 *	̍\̂́AscMetaImg NX̃pbg߂̋@\񋟂B
 *
 */
typedef struct
{
	//! pbg̐Ԑ
	unsigned char Red;
	//! pbg̗ΐ
	unsigned char Green;
	//! pbg̐
	unsigned char Blue;
	//! pbg̖gp̈
	unsigned char Reserved;
} SC_METAIMG_PALETTE;

//! ۉ摜f[^߂̃NX
/*!
 *	̃NX́Aۉ摜f[^߂̋@\񋟂B
 *	ff[^ void^z ɂĊi[B
 *	ff[^i[郁́ARXgN^AAResize ֐ɂĎIɊmۂB
 *	AResize ֐ɂČ̔z͔jAfi[AhXύX邱Ƃɗӂ邱ƁB
 *
 */
class scMetaImg
{
protected:
	/*!
	 * ff[^i[obt@̐擪AhXB
	 * eF̉ff[^ʏŃV[PVɊi[B
	 * 摜_͍B
	 *
	 * Cf[^̃TCÝA1oCg̔{łȂ΂ȂȂB
	 * line_bytesize = ( width * bit + 7 ) / 8
	 * width	: ̉f
	 * bit		: PF1f̏
	 */
	void *buf1d_;
	/*!
	 * ff[^̊eF̐擪AhX
	 */
	void **buf2d_;
	/*!
	 * 摜̕
	 */
	int width_;
	/*!
	 * 摜̍
	 */
	int height_;
	/*!
	 * PF1f̏
	 * 
	 * ł́A1bitA8 bitA16 bit ̂݃T|[gĂB
	 */
	int bit_;
	/*!
	 * F
	 * RGB摜ȂF=3ACfbNXJ[ȂF=1
	 */
	int channel_;
	/*!
	 * pbg
	 */
	SC_METAIMG_PALETTE *ary_palette_;
	/*!
	 * pbgTCY
	 */
	int palette_size_;

	/*!
	 * Rs[RXgN^
	 */
	scMetaImg( const scMetaImg & rhs );
//	scMetaImg & operator = ( const scMetaImg & rhs );		// Zq
//	scMetaImg * operator& (){ return this; };				// AhXZq
//	const scMetaImg * operator& () const{ return this; };	// AhXZq

	/*!
	 * Rs[
	 */
	void * MemCpy__( void *buf1, const void *buf2, int byte_size )
	{
		unsigned int *buf1_u32;
		const unsigned int *buf2_u32;
		int dword_size;
		int i;

		buf1_u32 = static_cast< unsigned int * >( buf1 );
		buf2_u32 = static_cast< const unsigned int * >( buf2 );
		dword_size = byte_size / 4;
		for( i = 0; i < dword_size; i ++ )
		{
			*buf1_u32 = *buf2_u32;
			buf1_u32 ++;
			buf2_u32 ++;
		}

		return buf1;
	}

	
public:
	/*!
	 * RXgN^
	 */
	scMetaImg()
	{
		buf1d_ = my_null;	// NULL
		buf2d_ = my_null;	// NULL
		width_ = 0;
		height_ = 0;
		bit_ = 0;
		channel_ = 0;
		palette_size_ = 0;
		ary_palette_ = my_null;	// NULL
	}

	/*!
	 * fXgN^
	 * buf1d_Abuf2d_ NULLł͖ꍇAB
	 */
	virtual ~scMetaImg()
	{
		//
		::delete [] buf2d_;
		::operator delete( buf1d_ );
		::delete [] ary_palette_;
	}

	/*!
	 * Zq
	 * gւ̑w肳ꂽꍇAȂB
	 */
	scMetaImg & operator = ( const scMetaImg & rhs )
	{
		// gւ̑ȂAȂD
		if( this == &rhs )
		{
			return *this;
		}

		// obt@̉Em
		Resize( &rhs );

		// ff[^̃Rs[
		int plane_size;
		int c;
		plane_size = width_ * height_ * ( ( bit_ + 7 ) >> 3 );
		for( c = 0; c < channel_; c ++ )
		{
//			std::memcpy( buf2d_[ c ], rhs.buf2d_[ c ], plane_size );
			MemCpy__( buf2d_[ c ], rhs.buf2d_[ c ], plane_size );
		}

		return *this;
	}

	/*!
	 *	@return	摜AB
	 */
	int Width() const
	{
		return width_;
	}

	/*!
	 *	@return	摜AB
	 */
	int Height() const
	{
		return height_;
	}

	/*!
	 *	@return	PF̃rbgAB
	 */
	int Bit() const
	{
		return bit_;
	}

	/*!
	 *	@return	FAB
	 */
	int Channel() const
	{
		return channel_;
	}

	/*!
	 *	@return	pbg̃AhXAB
	 */
	SC_METAIMG_PALETTE * Palette()
	{
		return ary_palette_;
	}
	/*!
	 *	@return	pbg̃AhX const SC_METAIMG_PALETTE * ŋAB
	 */
	const SC_METAIMG_PALETTE * CstPalette() const
	{
		return ary_palette_;
	}

	/*!
	 *	@return	pbgTCY()AB
	 */
	int PaletteSize() const
	{
		return palette_size_;
	}

	/*!
	 * DLLō\zCX^X́Ão֐sĂ͂ȂȂB
	 * 摜̍XVƃ̊mۂsȂB
	 * ֐ĂяoỎff[^͔jB
	 * TCY( buf_sizeAoCg )́Aȉ̂悤ɎZoB
	 *	@code
	 *	pix_size	= width * height;
	 *	plane_size	= pix_size * ( ( bit + 7 ) >> 3 );
	 *	buf_size	= plane_size * channel;
	 *	@endcode
	 *	@param[in]	width	V摜̕
	 *	@param[in]	height	V摜̍
	 *	@param[in]	bit		V摜̒PF̃rbg
	 *	@param[in]	channel	V摜̐F
	 *	@return	ꍇA0 ABsꍇA0 ȊOAB
	 */
	int Resize( int width, int height, int bit, int channel )
	{
		int result = -1;
		unsigned char *p_addr;
		int pix_size, plane_size, buf_size;
		int c;

		// TCY̍XV
		width_		= width;
		height_		= height;
		bit_		= bit;
		channel_	= channel;
		pix_size	= width * height;
		plane_size	= pix_size * ( ( bit + 7 ) >> 3 );
		buf_size	= ( plane_size * channel + 3 ) & ~3;	// 4ByteE

		// Ɨ̈mۂ
		try
		{
			if( buf1d_ )
			{
				::operator delete( buf1d_ );
			}
			if( buf2d_ )
			{
				delete [] buf2d_;
			}

			buf1d_ = ::operator new( buf_size );
			buf2d_ = ::new void*[ channel ];
			p_addr = static_cast< unsigned char * >( buf1d_ );
			for( c = 0; c < channel; c ++ )
			{
				buf2d_[ c ] = p_addr + c * plane_size;
			}

			//
			// pbg
			//

			// ݂̃pbgjB
			if( ary_palette_ )
			{
				::operator delete( ary_palette_ );
				ary_palette_ = my_null;
				palette_size_ = 0;
			}
			// `l1Ȃpbg쐬B
			if( channel_ == 1 )
			{
				int i;
				palette_size_ = 1 << bit_;
				ary_palette_ = static_cast< SC_METAIMG_PALETTE * >( ::operator new( sizeof( SC_METAIMG_PALETTE ) * palette_size_ ) );
				for( i = 0; i < palette_size_; i ++ )
				{
					ary_palette_[ i ].Blue = ary_palette_[ i ].Green = ary_palette_[ i ].Red = static_cast< unsigned char >( 0xFF * i / ( palette_size_ - 1 ) );
					ary_palette_[ i ].Reserved = 0xFF;
				}
			}
			result = 0;
		}
		catch( ... )
		{
			;
		}

		return result;
	}

	/*!
	 * DLLō\zCX^X́Ão֐sĂ͂ȂȂB
	 * ͂scMetaImg^ϐQƂA摜ƍXVƃ̊mۂsȂB
	 * 摜ƃTCÝAQƂCX^XƓɂȂB
	 * ֐ĂяoỎff[^͔jB
	 *	@param[in]	ref_img	QƂscMetaImg^ϐ̃|C^
	 *	@return	ꍇA0 ABsꍇA0 ȊOAB
	 */
	int Resize( const scMetaImg *ref_img )
	{
		int result;
		result = this->Resize( ref_img->Width(), ref_img->Height(), ref_img->Bit(), ref_img->Channel() );
		if( result == 0 && palette_size_ > 0 )
		{
			int i;
			for( i = 0; i < palette_size_; i ++ )
			{
				this->ary_palette_[ i ] = ref_img->ary_palette_[ i ];
			}
		}
		return result;
	}

	/*!
	 *	@param[in]	index	F̎w
	 *	@return	w肵F̉ff[^̐擪AhX void * ŋAB
	 */
	void *	ImgPtr( int index ) const
	{
		if( index >= channel_ )
		{
			// NULL
			return my_null;
		}
		return buf2d_[ index ];
	}

	/*!
	 *	@param[in]	index	F̎w
	 *	@return	w肵F̉ff[^̐擪AhX unsigned char * ŋAB
	 */
	unsigned char *	ImgPtr08( int index ) const
	{
		if( index >= channel_ )
		{
			// my_null
			return static_cast< unsigned char * >( 0 );
		}
		return static_cast< unsigned char * >( buf2d_[ index ] );
	}

	/*!
	 *	@param[in]	index	F̎w
	 *	@return	w肵F̉ff[^̐擪AhX unsigned short * ŋAB
	 */
	unsigned short *	ImgPtr16( int index ) const
	{
		if( index >= channel_ ){
			return my_null;
		}
		return static_cast< unsigned short * >( buf2d_[ index ] );
	}

	/*!
	 *	@param[in]	index	F̎w
	 *	@return	w肵F̉ff[^̐擪AhX const unsigned char * ŋAB
	 */
	const unsigned char *	CstImgPtr08( int index ) const
	{
		if( index >= channel_ ){
			return my_null;
		}
		return static_cast< const unsigned char * >( buf2d_[ index ] );
	}

	/*!
	 *	@param[in]	index	F̎w
	 *	@return	w肵F̉ff[^̐擪AhX const unsigned short * ŋAB
	 */
	const unsigned short *	CstImgPtr16( int index ) const
	{
		if( index >= channel_ ){
			return my_null;
		}
		return static_cast< const unsigned short * >( buf2d_[ index ] );
	}

	/*!
	 *	@return	eF̉ff[^̐擪AhX unsigned char ** ŋAB
	 */
	unsigned char **		ImgPtr08_2d() const
	{
		return reinterpret_cast< unsigned char ** >( buf2d_ );
	}

	/*!
	 * eF̉ff[^̐擪AhX unsigned short ** ŋAB
	 */
	unsigned short **	ImgPtr16_2d() const
	{
		return reinterpret_cast< unsigned short ** >( buf2d_ );
	}

	/*!
	 *	@return	eF̉ff[^̐擪AhX const unsigned char ** ŋAB
	 */
	const unsigned char **	CstImgPtr08_2d() const
	{
		return const_cast< const unsigned char ** >( reinterpret_cast< unsigned char ** >( buf2d_ ) );
	}

	/*!
	 *	@return	eF̉ff[^̐擪AhX const unsigned short ** ŋAB
	 */
	const unsigned short **	CstImgPtr16_2d() const
	{
		return const_cast< const unsigned short ** >( reinterpret_cast< unsigned short ** >( buf2d_ ) );
	}

};

#endif	//
